/*
 * ڹ α׷ Թ 
 *
 */

/**
 * @author ڹ α׷ Թ
 *
 *   ڹ α׷ Թ 縦  Դϴ. 
 * 
 */
public class EX14_14 {

	public static void main(String[] args) {
		// Product, Producer, Consumer ü  
		Product ex = new Product();
		// Product ü Producer, Consumer ü 
		Producer p = new Producer(ex);
		Consumer c = new Consumer(ex);
		Thread thread1 = new Thread(p);
		Thread thread2 = new Thread(c);
		//  
		thread1.start();
		thread2.start();
	}
}
class Product {
	private boolean available = false;
	private int num = 0;
	public synchronized  void put(int x) {
		if (x > 0)
			num += x;
		available = true;
		notifyAll();
	}
	public synchronized int get(int x) {
		int rtn = 0;
		if (!available) {
			try {
				wait();
			} catch (Exception e)
			{
				e.printStackTrace();
			}
		}
		if (x == 0 || x > num) {
			rtn = num;
			num = 0;
			available = false;
		} else if (x > 0) {
			rtn = x;
			num = num - x;
		}
		return rtn;
			
	}
}

class Producer implements Runnable {
	private Product share;
	public Producer(Product p)
	{
		this.share = p;
	}
	public void run()
	{
		try {
			while(true) 
			{
				int x = (int) (Math.random() * 5) + 1;
				System.out.println("Products produced:" + x);
				Thread.sleep(1000);
				share.put(x);
			}
		} catch (Exception e) 
		{
			e.printStackTrace();
		}
	}
}
class Consumer implements Runnable {
	private Product share;
	public Consumer(Product p)
	{
		this.share = p;
	}
	public void run()
	{
		while(true) 
		{
			int x = (int) (Math.random() * 5);
			try {
				Thread.sleep(500);
				System.out.println("Products consumed:" + share.get(x));
			} catch (Exception e) 
			{
				e.printStackTrace();
			}
		}
	}
}
